using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Trains
{
    public class Trains
    {
        public static void Main()
        {
            ModAPI2.metaString = ModAPI.Metadata.MetaLocation;
            //KTX
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "KTX",
                    NameToOrderByOverride = "3 1",
                    DescriptionOverride = "A train as known as train from <Train to Busan>",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/ktx.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                       
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 160;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 160;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 160;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<KtxSetUp>())
                            Instance.AddComponent<KtxSetUp>();
                        if (!Instance.GetComponent<Locomotive>())
                            Instance.AddComponent<Locomotive>();
                        Instance.GetComponent<Locomotive>().health = 200;
                        Instance.GetComponent<Locomotive>().maxSpeed = 800f;
                        Instance.GetComponent<Locomotive>().power = 158400f;
                        Instance.GetComponent<Locomotive>().accelation = 800f;
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("ktx.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<Locomotive>().release = ModAPI2.LoadSound("sounds/release/ktx.wav");
                        Instance.GetComponent<Locomotive>().loop = ModAPI2.LoadSound("sounds/loop/default.wav");
                        Instance.GetComponent<Locomotive>().run = ModAPI2.LoadSound("sounds/run/ktx.wav");

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );

            //KTX wagon
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "KTX wagon",
                    NameToOrderByOverride = "3 1",
                    DescriptionOverride = "The wagon for KTX",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/ktxWagon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 120;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 120;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 120;
                        if (!Instance.GetComponent<KtxWagonSetUp>())
                            Instance.AddComponent<KtxWagonSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<RandomSpriteBehaviour>())
                            Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI2.LoadSprite("ktxWagon.png"),
                            ModAPI2.LoadSprite("ktxWagon_e.png"),
                        };
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("ktxWagon.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var floor = Instance.AddComponent<BoxCollider2D>();
                        floor.offset = new Vector2(0f, -1.75f);
                        floor.size = new Vector2(23.4f, 0.8f);
                        var ceiling = Instance.AddComponent<BoxCollider2D>();
                        ceiling.offset = new Vector2(0f, 1.75f);
                        ceiling.size = new Vector2(23.4f, 0.2f);
                        var Lwall = Instance.AddComponent<BoxCollider2D>();
                        Lwall.offset = new Vector2(-11.6f, 1.29f);
                        Lwall.size = new Vector2(0.2f, 0.8f);
                        var Rwall = Instance.AddComponent<BoxCollider2D>();
                        Rwall.offset = new Vector2(11.6f, 1.29f);
                        Rwall.size = new Vector2(0.2f, 0.8f);

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );

            //BasicTrain
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "EMD SD40-2",
                    NameToOrderByOverride = "1 1",
                    DescriptionOverride = "The best seller diesel locomotive. it is usual. yes. nothing more to describe this thing.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/sd40.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 200;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 200;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 200;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<BasicDieselLocomotiveSetUp>())
                            Instance.AddComponent<BasicDieselLocomotiveSetUp>();
                        if (!Instance.GetComponent<Locomotive>())
                            Instance.AddComponent<Locomotive>();
                        Instance.GetComponent<Locomotive>().health = 150;
                        Instance.GetComponent<Locomotive>().maxSpeed = 105f;
                        Instance.GetComponent<Locomotive>().power = 369647f;
                        Instance.GetComponent<Locomotive>().accelation = 80f;
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("EMD_SD40_body.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<Locomotive>().release = ModAPI2.LoadSound("sounds/release/sd40.wav");
                        Instance.GetComponent<Locomotive>().loop = ModAPI2.LoadSound("sounds/loop/default.wav");
                        Instance.GetComponent<Locomotive>().run = ModAPI2.LoadSound("sounds/run/sd40.wav");

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );

            //C62
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "C62",
                    NameToOrderByOverride = "2 1",
                    DescriptionOverride = "Japanese best steam train that is famous for <Galaxy express 999>. it is small and uses narrow gauge, it is stronger and faster than you think.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/c62.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 160;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 160;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 160;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<C62SetUp>())
                            Instance.AddComponent<C62SetUp>();
                        if (!Instance.GetComponent<Locomotive>())
                            Instance.AddComponent<Locomotive>();
                        Instance.GetComponent<Locomotive>().isSteam = true;
                        Instance.GetComponent<Locomotive>().health = 150;
                        Instance.GetComponent<Locomotive>().maxSpeed = 129f;
                        Instance.GetComponent<Locomotive>().power = 369647f;
                        Instance.GetComponent<Locomotive>().accelation = 40f;
                        Instance.GetComponent<Locomotive>().horn = ModAPI2.LoadSound("sounds/horn/C62.wav");
                        Instance.GetComponent<Locomotive>().release = ModAPI2.LoadSound("sounds/release/C62.wav");
                        Instance.GetComponent<Locomotive>().loop = ModAPI2.LoadSound("sounds/loop/default.wav");
                        Instance.GetComponent<Locomotive>().run = ModAPI2.LoadSound("sounds/run/C62.wav");
                        Instance.GetComponent<Locomotive>().brush = ModAPI2.LoadSound("sounds/brush/C62.wav");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("C62.png", 1f);
                        Instance.AddComponent<PolygonCollider2D>();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );

            //C62 tender
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "C62 tender",
                    NameToOrderByOverride = "2 2",
                    DescriptionOverride = "tender of C62",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/c62tender.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 100;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 100;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 100;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<C62TenderSetUp>())
                            Instance.AddComponent<C62TenderSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("c62_tender.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {

                        };
                    }
                }
            );

            //bigBoy
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Big Boy",
                    NameToOrderByOverride = "2 3",
                    DescriptionOverride = "An old steam train from 1941. but it is usually as twice as stronger than nowday's locomotives. and it is also the biggest locomotive has ever made.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/bigboy.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 400;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 400;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 400;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<BigBoySetUp>())
                            Instance.AddComponent<BigBoySetUp>();
                        if (!Instance.GetComponent<Locomotive>())
                            Instance.AddComponent<Locomotive>();
                        Instance.GetComponent<Locomotive>().isSteam = true;
                        Instance.GetComponent<Locomotive>().health = 4000;
                        Instance.GetComponent<Locomotive>().maxSpeed = 130;
                        Instance.GetComponent<Locomotive>().power = 802180f;
                        Instance.GetComponent<Locomotive>().accelation = 12f;
                        Instance.GetComponent<Locomotive>().horn = ModAPI2.LoadSound("sounds/horn/BigBoy.wav");
                        Instance.GetComponent<Locomotive>().release = ModAPI2.LoadSound("sounds/release/BigBoy.wav");
                        Instance.GetComponent<Locomotive>().loop = ModAPI2.LoadSound("sounds/loop/default.wav");
                        Instance.GetComponent<Locomotive>().run = ModAPI2.LoadSound("sounds/run/BigBoy.wav");
                        Instance.GetComponent<Locomotive>().brush = ModAPI2.LoadSound("sounds/brush/C62.wav");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("BigBoy.png", 1f);
                        Instance.AddComponent<PolygonCollider2D>();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );

            //bigBoy tender
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Big Boy tender",
                    NameToOrderByOverride = "2 4",
                    DescriptionOverride = "tender of Big Boy",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/bigboytender.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 300;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 300;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 300;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<BigBoyTenderSetUp>())
                            Instance.AddComponent<BigBoyTenderSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("BigBoyTender.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {

                        };
                    }
                }
            );

            //1225
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Pere Marquette 1225",
                    NameToOrderByOverride = "2 5",
                    DescriptionOverride = "Polar express.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/1225.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 300;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 300;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 300;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<MarquetteSetUp>())
                            Instance.AddComponent<MarquetteSetUp>();
                        if (!Instance.GetComponent<Locomotive>())
                            Instance.AddComponent<Locomotive>();
                        Instance.GetComponent<Locomotive>().isSteam = true;
                        Instance.GetComponent<Locomotive>().health = 250;
                        Instance.GetComponent<Locomotive>().maxSpeed = 100f;
                        Instance.GetComponent<Locomotive>().power = 289647f;
                        Instance.GetComponent<Locomotive>().accelation = 40f;
                        Instance.GetComponent<Locomotive>().horn = ModAPI2.LoadSound("sounds/horn/C62.wav");
                        Instance.GetComponent<Locomotive>().release = ModAPI2.LoadSound("sounds/release/C62.wav");
                        Instance.GetComponent<Locomotive>().loop = ModAPI2.LoadSound("sounds/loop/default.wav");
                        Instance.GetComponent<Locomotive>().run = ModAPI2.LoadSound("sounds/run/C62.wav");
                        Instance.GetComponent<Locomotive>().brush = ModAPI2.LoadSound("sounds/brush/C62.wav");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("1225.png", 1f);
                        Instance.AddComponent<PolygonCollider2D>();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );

            //1225 tender
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Pere Marquette tender",
                    NameToOrderByOverride = "2 6",
                    DescriptionOverride = "tender of Pere Marquette",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/1225tender.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 200;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 200;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 200;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<MarquetteTenderSetUp>())
                            Instance.AddComponent<MarquetteTenderSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("1225_tender.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {

                        };
                    }
                }
            );

            //boxcar
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Boxcar",
                    NameToOrderByOverride = "5 1",
                    DescriptionOverride = "A wagon that can carry various things in. if you want to put things in this boxcar, stop the time with space bar, then drag things into inside of it.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/boxcar.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 60;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<BoxcarSetUp>())
                            Instance.AddComponent<BoxcarSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        if (!Instance.GetComponent<RandomSpriteBehaviour>())
                            Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI2.LoadSprite("boxcar.png"),
                            ModAPI2.LoadSprite("boxcar_e.png"),
                            ModAPI2.LoadSprite("boxcar_o.png"),
                        };
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("boxcar.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var floor = Instance.AddComponent<BoxCollider2D>();
                        floor.offset = new Vector2(0f, -2f);
                        floor.size = new Vector2(19f, 1f);
                        var ceiling = Instance.AddComponent<BoxCollider2D>();
                        ceiling.offset = new Vector2(0f, 1.9f);
                        ceiling.size = new Vector2(19f, 0.4f);
                        var Lwall = Instance.AddComponent<BoxCollider2D>();
                        Lwall.offset = new Vector2(-9.45f, 0f);
                        Lwall.size = new Vector2(0.16f, 4.25f);
                        var Rwall = Instance.AddComponent<BoxCollider2D>();
                        Rwall.offset = new Vector2(9.45f, 0f);
                        Rwall.size = new Vector2(0.16f, 4.25f);

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {

                        };
                    }
                }
            );

            //opencar
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Opencar",
                    NameToOrderByOverride = "5 2",
                    DescriptionOverride = "A wagon that can carry things in. especially things that is too big to get into a Boxcar.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/opencar.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 50;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 50;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 50;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<BoxcarSetUp>())
                            Instance.AddComponent<BoxcarSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("opencar.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var floor = Instance.AddComponent<BoxCollider2D>();
                        floor.offset = new Vector2(0f, -2f);
                        floor.size = new Vector2(19f, 1f);
                        var Lwall = Instance.AddComponent<BoxCollider2D>();
                        Lwall.offset = new Vector2(-9.45f, -1.49f);
                        Lwall.size = new Vector2(0.16f, 1f);
                        var Rwall = Instance.AddComponent<BoxCollider2D>();
                        Rwall.offset = new Vector2(9.45f, -1.49f);
                        Rwall.size = new Vector2(0.16f, 1f);

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {

                        };
                    }
                }
            );

            //orecar
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Orecar",
                    NameToOrderByOverride = "5 3",
                    DescriptionOverride = "A wagon that can carry things in. especially materials like iron, coal, gravel, sand and dirt.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/orecar.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 60;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<OrecarSetUp>())
                            Instance.AddComponent<OrecarSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("orecar.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var floor = Instance.AddComponent<BoxCollider2D>();
                        floor.offset = new Vector2(0f, -2.16f);
                        floor.size = new Vector2(16f, 1f);
                        var Lwall1 = Instance.AddComponent<BoxCollider2D>();
                        Lwall1.offset = new Vector2(-6.75f, -1.49f);
                        Lwall1.size = new Vector2(0.36f, 0.36f);
                        var Lwall2 = Instance.AddComponent<BoxCollider2D>();
                        Lwall2.offset = new Vector2(-6.97f, -1.1f);
                        Lwall2.size = new Vector2(0.36f, 0.36f);
                        var Lwall3 = Instance.AddComponent<BoxCollider2D>();
                        Lwall3.offset = new Vector2(-7.11f, -0.77f);
                        Lwall3.size = new Vector2(0.36f, 0.36f);
                        var Lwall4 = Instance.AddComponent<BoxCollider2D>();
                        Lwall4.offset = new Vector2(-7.19f, -0.41f);
                        Lwall4.size = new Vector2(0.36f, 0.36f);
                        var Lwall5 = Instance.AddComponent<BoxCollider2D>();
                        Lwall5.offset = new Vector2(-7.4f, -0.04f);
                        Lwall5.size = new Vector2(0.36f, 0.36f);
                        var Lwall6 = Instance.AddComponent<BoxCollider2D>();
                        Lwall6.offset = new Vector2(-7.53f, 0.28f);
                        Lwall6.size = new Vector2(0.36f, 0.36f);
                        var Lwall7 = Instance.AddComponent<BoxCollider2D>();
                        Lwall7.offset = new Vector2(-7.56f, 0.68f);
                        Lwall7.size = new Vector2(0.36f, 0.6f);

                        var Rwall1 = Instance.AddComponent<BoxCollider2D>();
                        Rwall1.offset = new Vector2(6.75f, -1.49f);
                        Rwall1.size = new Vector2(0.36f, 0.36f);
                        var Rwall2 = Instance.AddComponent<BoxCollider2D>();
                        Rwall2.offset = new Vector2(6.97f, -1.1f);
                        Rwall2.size = new Vector2(0.36f, 0.36f);
                        var Rwall3 = Instance.AddComponent<BoxCollider2D>();
                        Rwall3.offset = new Vector2(7.11f, -0.77f);
                        Rwall3.size = new Vector2(0.36f, 0.36f);
                        var Rwall4 = Instance.AddComponent<BoxCollider2D>();
                        Rwall4.offset = new Vector2(7.19f, -0.41f);
                        Rwall4.size = new Vector2(0.36f, 0.36f);
                        var Rwall5 = Instance.AddComponent<BoxCollider2D>();
                        Rwall5.offset = new Vector2(7.4f, -0.04f);
                        Rwall5.size = new Vector2(0.36f, 0.36f);
                        var Rwall6 = Instance.AddComponent<BoxCollider2D>();
                        Rwall6.offset = new Vector2(7.53f, 0.28f);
                        Rwall6.size = new Vector2(0.36f, 0.36f);
                        var Rwall7 = Instance.AddComponent<BoxCollider2D>();
                        Rwall7.offset = new Vector2(7.56f, 0.68f);
                        Rwall7.size = new Vector2(0.36f, 0.6f);
                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {

                        };
                    }
                }
            );

            //wagon
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Basic wagon",
                    NameToOrderByOverride = "6 1",
                    DescriptionOverride = "A wagon. but I know that you are gonna use this as not wagon but torture machine or coffin for rectangular meaningless people.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/wagon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 60;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<WagonSetUp>())
                            Instance.AddComponent<WagonSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        if (!Instance.GetComponent<RandomSpriteBehaviour>())
                            Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI2.LoadSprite("wagonBlue.png"),
                            ModAPI2.LoadSprite("wagonBlue_e.png"),
                        };
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("wagonBlue.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var floor = Instance.AddComponent<BoxCollider2D>();
                        floor.offset = new Vector2(0f, -1.8f);
                        floor.size = new Vector2(23f, 1f);
                        var ceiling = Instance.AddComponent<BoxCollider2D>();
                        ceiling.offset = new Vector2(0f, 1.95f);
                        ceiling.size = new Vector2(22.9f, 0.4f);
                        var Lwall = Instance.AddComponent<BoxCollider2D>();
                        Lwall.offset = new Vector2(-11.38f, 1.6f);
                        Lwall.size = new Vector2(0.14f, 0.8f);
                        var Rwall = Instance.AddComponent<BoxCollider2D>();
                        Rwall.offset = new Vector2(11.38f, 1.6f);
                        Rwall.size = new Vector2(0.14f, 0.8f);
                    }
                }
            );

            //Caboose
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Caboose",
                    NameToOrderByOverride = "5 20",
                    DescriptionOverride = "A wagon in which conducter of train is.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/caboose.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 60;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 60;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<CabooseSetUp>())
                            Instance.AddComponent<CabooseSetUp>();
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        if (!Instance.GetComponent<RandomSpriteBehaviour>())
                            Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                        //Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        //{
                        //    ModAPI2.LoadSprite("wagonBlue.png"),
                        //    ModAPI2.LoadSprite("wagonBlue_e.png"),
                        //};
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("caboose.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var floor = Instance.AddComponent<BoxCollider2D>();
                        floor.offset = new Vector2(0f, -2.1f);
                        floor.size = new Vector2(18f, 0.8f);
                        var ceiling = Instance.AddComponent<BoxCollider2D>();
                        ceiling.offset = new Vector2(0f, 1.5f);
                        ceiling.size = new Vector2(18f, 0.2f);
                        var what = Instance.AddComponent<BoxCollider2D>();
                        what.offset = new Vector2(-4.2f, 2.07f);
                        what.size = new Vector2(4.37f, 1f);
                    }
                }
            );

            //TankCar
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Tank car",
                    NameToOrderByOverride = "5 5",
                    DescriptionOverride = "You know what it does. U know, booom thing.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/tankcar.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 80;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 80;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 80;
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<BasiFlatbedSetUpDdamBbang>())
                            Instance.AddComponent<BasiFlatbedSetUpDdamBbang>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("TankCar.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.AddComponent<ExplodableCart>();
                    }
                }
            );

            //gustav
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Schwerer gustav",
                    NameToOrderByOverride = "7 1",
                    DescriptionOverride = "The biggest railroad cannon that uses 800mm ball to destroy entire buildings. it is sooooo strong. but everything except power is its weakness.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/gustav.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 800;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 800;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 800;
                        if (!Instance.GetComponent<GustavSetUp>())
                            Instance.AddComponent<GustavSetUp>();
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<Locomotive>())
                            Instance.AddComponent<Locomotive>();
                        Instance.GetComponent<Locomotive>().health = 4000;
                        Instance.GetComponent<Locomotive>().maxSpeed = 80;
                        Instance.GetComponent<Locomotive>().power = 402180f;
                        Instance.GetComponent<Locomotive>().accelation = 12f;
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("gustav.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<Locomotive>().release = ModAPI2.LoadSound("sounds/release/sd40.wav");
                        Instance.GetComponent<Locomotive>().loop = ModAPI2.LoadSound("sounds/loop/default.wav");
                        Instance.GetComponent<Locomotive>().run = ModAPI2.LoadSound("sounds/run/sd40.wav");

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );

            //armoured train
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Anchor"),
                    NameOverride = "Armoured train",
                    NameToOrderByOverride = "7 2",
                    DescriptionOverride = "A train with gun and metal plate.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/armored.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 200;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 200;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 200;
                        if (!Instance.GetComponent<ArmSetUp>())
                            Instance.AddComponent<ArmSetUp>();
                        if (!Instance.GetComponent<TrainCart>())
                            Instance.AddComponent<TrainCart>();
                        if (!Instance.GetComponent<Locomotive>())
                            Instance.AddComponent<Locomotive>();
                        Instance.GetComponent<Locomotive>().health = 1200;
                        Instance.GetComponent<Locomotive>().maxSpeed = 80;
                        Instance.GetComponent<Locomotive>().power = 12080f;
                        Instance.GetComponent<Locomotive>().accelation = 12f;
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("armoredTrain.png", 1f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<Locomotive>().release = ModAPI2.LoadSound("sounds/release/sd40.wav");
                        Instance.GetComponent<Locomotive>().loop = ModAPI2.LoadSound("sounds/loop/default.wav");
                        Instance.GetComponent<Locomotive>().run = ModAPI2.LoadSound("sounds/run/sd40.wav");

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Instance.GetComponent<Locomotive>().switchEngine();
                        };
                    }
                }
            );



            //Coal
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Coal",
                    NameToOrderByOverride = "1 1",
                    DescriptionOverride = "Fuel of steam locomotives. you can put only 5 per each engines. or the locomotive will blow up. also it can be crafted with stick to be torch.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI2.LoadSprite("icons/coal.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.Notify(ModAPI.Metadata.MetaLocation);
                        if (!Instance.GetComponent<CoalBehaviour>())
                            Instance.AddComponent<CoalBehaviour>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI2.LoadSprite("coal.png", 1f);
                        Instance.transform.localScale = new Vector2(0.2f, 0.2f);
                        Instance.AddComponent<PolygonCollider2D>();
                    }
                }
            );
        }
    }
}